import type { ReqConfig } from '@/types/dataAnalysis'
import type { FormRules } from 'element-plus'
import type { VNode } from 'vue'

export type ValueTypes = 'string' | 'int' | 'float' | 'boolean'

export enum FormFieldType {
  SELECT = 'select',
  INPUT = 'input',
  RICHTEXT = 'richText',
  SWITCH = 'switch'
}

export interface FormField {
  name: string
  cnName: string
  type: FormFieldType
  valueType?: ValueTypes
  defaultValue?: any
  otherOptions?: {
    placeholder?: string
    tip?: string | (() => string | VNode)
    options?: Array<{ name: string; label: string; value: any }>
  }
}

export interface FormConfig {
  reqConfig: ReqConfig
  fieldsInfo: Array<FormField>
  rules: FormRules
}
